// services/network/public/mojom/connection_endpoint_metadata.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_CONNECTION_ENDPOINT_METADATA_MOJOM_BLINK_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_CONNECTION_ENDPOINT_METADATA_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/network/public/mojom/connection_endpoint_metadata.mojom-features.h"  // IWYU pragma: export
#include "services/network/public/mojom/connection_endpoint_metadata.mojom-shared.h"  // IWYU pragma: export
#include "services/network/public/mojom/connection_endpoint_metadata.mojom-blink-forward.h"  // IWYU pragma: export

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"








namespace network::mojom::blink {








class  ConnectionEndpointMetadata {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ConnectionEndpointMetadata, T>::value>;
  using DataView = ConnectionEndpointMetadataDataView;
  using Data_ = internal::ConnectionEndpointMetadata_Data;

  template <typename... Args>
  static ConnectionEndpointMetadataPtr New(Args&&... args) {
    return ConnectionEndpointMetadataPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ConnectionEndpointMetadataPtr From(const U& u) {
    return mojo::TypeConverter<ConnectionEndpointMetadataPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ConnectionEndpointMetadata>::Convert(*this);
  }


  ConnectionEndpointMetadata();

  ConnectionEndpointMetadata(
      WTF::Vector<WTF::String> supported_protocol_alpns,
      WTF::Vector<uint8_t> ech_config_list,
      const WTF::String& target_name);


  ~ConnectionEndpointMetadata();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ConnectionEndpointMetadataPtr>
  ConnectionEndpointMetadataPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ConnectionEndpointMetadata::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, ConnectionEndpointMetadata::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, ConnectionEndpointMetadata::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ConnectionEndpointMetadata::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ConnectionEndpointMetadata::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ConnectionEndpointMetadata_UnserializedMessageContext<
            UserType, ConnectionEndpointMetadata::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<ConnectionEndpointMetadata::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return ConnectionEndpointMetadata::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ConnectionEndpointMetadata_UnserializedMessageContext<
            UserType, ConnectionEndpointMetadata::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ConnectionEndpointMetadata::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  WTF::Vector<WTF::String> supported_protocol_alpns;
  
  WTF::Vector<uint8_t> ech_config_list;
  
  WTF::String target_name;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ConnectionEndpointMetadata::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ConnectionEndpointMetadata::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ConnectionEndpointMetadata::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ConnectionEndpointMetadata::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
ConnectionEndpointMetadataPtr ConnectionEndpointMetadata::Clone() const {
  return New(
      mojo::Clone(supported_protocol_alpns),
      mojo::Clone(ech_config_list),
      mojo::Clone(target_name)
  );
}

template <typename T, ConnectionEndpointMetadata::EnableIfSame<T>*>
bool ConnectionEndpointMetadata::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->supported_protocol_alpns, other_struct.supported_protocol_alpns))
    return false;
  if (!mojo::Equals(this->ech_config_list, other_struct.ech_config_list))
    return false;
  if (!mojo::Equals(this->target_name, other_struct.target_name))
    return false;
  return true;
}

template <typename T, ConnectionEndpointMetadata::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.supported_protocol_alpns < rhs.supported_protocol_alpns)
    return true;
  if (rhs.supported_protocol_alpns < lhs.supported_protocol_alpns)
    return false;
  if (lhs.ech_config_list < rhs.ech_config_list)
    return true;
  if (rhs.ech_config_list < lhs.ech_config_list)
    return false;
  if (lhs.target_name < rhs.target_name)
    return true;
  if (rhs.target_name < lhs.target_name)
    return false;
  return false;
}


}  // network::mojom::blink

namespace mojo {


template <>
struct  StructTraits<::network::mojom::blink::ConnectionEndpointMetadata::DataView,
                                         ::network::mojom::blink::ConnectionEndpointMetadataPtr> {
  static bool IsNull(const ::network::mojom::blink::ConnectionEndpointMetadataPtr& input) { return !input; }
  static void SetToNull(::network::mojom::blink::ConnectionEndpointMetadataPtr* output) { output->reset(); }

  static const decltype(::network::mojom::blink::ConnectionEndpointMetadata::supported_protocol_alpns)& supported_protocol_alpns(
      const ::network::mojom::blink::ConnectionEndpointMetadataPtr& input) {
    return input->supported_protocol_alpns;
  }

  static const decltype(::network::mojom::blink::ConnectionEndpointMetadata::ech_config_list)& ech_config_list(
      const ::network::mojom::blink::ConnectionEndpointMetadataPtr& input) {
    return input->ech_config_list;
  }

  static const decltype(::network::mojom::blink::ConnectionEndpointMetadata::target_name)& target_name(
      const ::network::mojom::blink::ConnectionEndpointMetadataPtr& input) {
    return input->target_name;
  }

  static bool Read(::network::mojom::blink::ConnectionEndpointMetadata::DataView input, ::network::mojom::blink::ConnectionEndpointMetadataPtr* output);
};

}  // namespace mojo

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_CONNECTION_ENDPOINT_METADATA_MOJOM_BLINK_H_