// third_party/blink/public/mojom/ai/ai_manager.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "third_party/blink/public/mojom/ai/ai_manager.mojom-shared.h"

// Used to support stream output operator for enums.
// TODO(dcheng): Consider omitting this somehow if not needed.
#include <ostream>
#include <utility>

#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "third_party/blink/public/mojom/ai/ai_manager.mojom-params-data.h"
namespace blink {
namespace mojom {

NOINLINE static const char* ModelAvailabilityCheckResultToStringHelper(ModelAvailabilityCheckResult value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case ModelAvailabilityCheckResult::kReadily:
      return "kReadily";
    case ModelAvailabilityCheckResult::kAfterDownload:
      return "kAfterDownload";
    case ModelAvailabilityCheckResult::kNoServiceNotRunning:
      return "kNoServiceNotRunning";
    case ModelAvailabilityCheckResult::kNoUnknown:
      return "kNoUnknown";
    case ModelAvailabilityCheckResult::kNoFeatureNotEnabled:
      return "kNoFeatureNotEnabled";
    case ModelAvailabilityCheckResult::kNoModelNotAvailable:
      return "kNoModelNotAvailable";
    case ModelAvailabilityCheckResult::kNoConfigNotAvailableForFeature:
      return "kNoConfigNotAvailableForFeature";
    case ModelAvailabilityCheckResult::kNoGpuBlocked:
      return "kNoGpuBlocked";
    case ModelAvailabilityCheckResult::kNoTooManyRecentCrashes:
      return "kNoTooManyRecentCrashes";
    case ModelAvailabilityCheckResult::kNoTooManyRecentTimeouts:
      return "kNoTooManyRecentTimeouts";
    case ModelAvailabilityCheckResult::kNoSafetyModelNotAvailable:
      return "kNoSafetyModelNotAvailable";
    case ModelAvailabilityCheckResult::kNoSafetyConfigNotAvailableForFeature:
      return "kNoSafetyConfigNotAvailableForFeature";
    case ModelAvailabilityCheckResult::kNoLanguageDetectionModelNotAvailable:
      return "kNoLanguageDetectionModelNotAvailable";
    case ModelAvailabilityCheckResult::kNoFeatureExecutionNotEnabled:
      return "kNoFeatureExecutionNotEnabled";
    case ModelAvailabilityCheckResult::kNoModelAdaptationNotAvailable:
      return "kNoModelAdaptationNotAvailable";
    case ModelAvailabilityCheckResult::kNoValidationPending:
      return "kNoValidationPending";
    case ModelAvailabilityCheckResult::kNoValidationFailed:
      return "kNoValidationFailed";
    default:
      return nullptr;
  }
}

std::string ModelAvailabilityCheckResultToString(ModelAvailabilityCheckResult value) {
  const char *str = ModelAvailabilityCheckResultToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown ModelAvailabilityCheckResult value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, ModelAvailabilityCheckResult value) {
  return os << ModelAvailabilityCheckResultToString(value);
}

NOINLINE static const char* AIAssistantInitialPromptRoleToStringHelper(AIAssistantInitialPromptRole value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case AIAssistantInitialPromptRole::kSystem:
      return "kSystem";
    case AIAssistantInitialPromptRole::kUser:
      return "kUser";
    case AIAssistantInitialPromptRole::kAssistant:
      return "kAssistant";
    default:
      return nullptr;
  }
}

std::string AIAssistantInitialPromptRoleToString(AIAssistantInitialPromptRole value) {
  const char *str = AIAssistantInitialPromptRoleToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown AIAssistantInitialPromptRole value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, AIAssistantInitialPromptRole value) {
  return os << AIAssistantInitialPromptRoleToString(value);
}

namespace internal {


// static
bool AIAssistantInitialPrompt_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AIAssistantInitialPrompt_Data* object =
      static_cast<const AIAssistantInitialPrompt_Data*>(data);


  if (!::blink::mojom::internal::AIAssistantInitialPromptRole_Data
        ::Validate(object->role, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->content, 2, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& content_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->content, validation_context,
                                         &content_validate_params)) {
    return false;
  }

  return true;
}

AIAssistantInitialPrompt_Data::AIAssistantInitialPrompt_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AIManagerCreateWriterClient_OnResult_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AIManagerCreateWriterClient_OnResult_Params_Data* object =
      static_cast<const AIManagerCreateWriterClient_OnResult_Params_Data*>(data);

  if (!mojo::internal::ValidateHandleOrInterface(object->writer,
                                                 validation_context)) {
    return false;
  }

  return true;
}

AIManagerCreateWriterClient_OnResult_Params_Data::AIManagerCreateWriterClient_OnResult_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AIManagerCreateRewriterClient_OnResult_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AIManagerCreateRewriterClient_OnResult_Params_Data* object =
      static_cast<const AIManagerCreateRewriterClient_OnResult_Params_Data*>(data);

  if (!mojo::internal::ValidateHandleOrInterface(object->rewriter,
                                                 validation_context)) {
    return false;
  }

  return true;
}

AIManagerCreateRewriterClient_OnResult_Params_Data::AIManagerCreateRewriterClient_OnResult_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AIManagerCreateSummarizerClient_OnResult_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AIManagerCreateSummarizerClient_OnResult_Params_Data* object =
      static_cast<const AIManagerCreateSummarizerClient_OnResult_Params_Data*>(data);

  if (!mojo::internal::ValidateHandleOrInterface(object->summarizer,
                                                 validation_context)) {
    return false;
  }

  return true;
}

AIManagerCreateSummarizerClient_OnResult_Params_Data::AIManagerCreateSummarizerClient_OnResult_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AIManager_CanCreateTextSession_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AIManager_CanCreateTextSession_Params_Data* object =
      static_cast<const AIManager_CanCreateTextSession_Params_Data*>(data);

  return true;
}

AIManager_CanCreateTextSession_Params_Data::AIManager_CanCreateTextSession_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AIManager_CanCreateTextSession_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AIManager_CanCreateTextSession_ResponseParams_Data* object =
      static_cast<const AIManager_CanCreateTextSession_ResponseParams_Data*>(data);


  if (!::blink::mojom::internal::ModelAvailabilityCheckResult_Data
        ::Validate(object->result, validation_context))
    return false;

  return true;
}

AIManager_CanCreateTextSession_ResponseParams_Data::AIManager_CanCreateTextSession_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AIManager_CreateTextSession_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 40, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AIManager_CreateTextSession_Params_Data* object =
      static_cast<const AIManager_CreateTextSession_Params_Data*>(data);

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->session, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->session,
                                                 validation_context)) {
    return false;
  }

  if (!mojo::internal::ValidateStruct(object->sampling_params, validation_context))
    return false;

  constexpr const mojo::internal::ContainerValidateParams& system_prompt_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->system_prompt, validation_context,
                                         &system_prompt_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->initial_prompts, 4, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& initial_prompts_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->initial_prompts, validation_context,
                                         &initial_prompts_validate_params)) {
    return false;
  }

  return true;
}

AIManager_CreateTextSession_Params_Data::AIManager_CreateTextSession_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AIManager_CreateTextSession_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AIManager_CreateTextSession_ResponseParams_Data* object =
      static_cast<const AIManager_CreateTextSession_ResponseParams_Data*>(data);

  if (!mojo::internal::ValidateStruct(object->info, validation_context))
    return false;

  return true;
}

AIManager_CreateTextSession_ResponseParams_Data::AIManager_CreateTextSession_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AIManager_CanCreateSummarizer_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AIManager_CanCreateSummarizer_Params_Data* object =
      static_cast<const AIManager_CanCreateSummarizer_Params_Data*>(data);

  return true;
}

AIManager_CanCreateSummarizer_Params_Data::AIManager_CanCreateSummarizer_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AIManager_CanCreateSummarizer_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AIManager_CanCreateSummarizer_ResponseParams_Data* object =
      static_cast<const AIManager_CanCreateSummarizer_ResponseParams_Data*>(data);


  if (!::blink::mojom::internal::ModelAvailabilityCheckResult_Data
        ::Validate(object->result, validation_context))
    return false;

  return true;
}

AIManager_CanCreateSummarizer_ResponseParams_Data::AIManager_CanCreateSummarizer_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AIManager_CreateSummarizer_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AIManager_CreateSummarizer_Params_Data* object =
      static_cast<const AIManager_CreateSummarizer_Params_Data*>(data);

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->client, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->client,
                                                 validation_context)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->options, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->options, validation_context))
    return false;

  return true;
}

AIManager_CreateSummarizer_Params_Data::AIManager_CreateSummarizer_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AIManager_GetTextModelInfo_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AIManager_GetTextModelInfo_Params_Data* object =
      static_cast<const AIManager_GetTextModelInfo_Params_Data*>(data);

  return true;
}

AIManager_GetTextModelInfo_Params_Data::AIManager_GetTextModelInfo_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AIManager_GetTextModelInfo_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AIManager_GetTextModelInfo_ResponseParams_Data* object =
      static_cast<const AIManager_GetTextModelInfo_ResponseParams_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->text_model_info, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->text_model_info, validation_context))
    return false;

  return true;
}

AIManager_GetTextModelInfo_ResponseParams_Data::AIManager_GetTextModelInfo_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AIManager_CreateWriter_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AIManager_CreateWriter_Params_Data* object =
      static_cast<const AIManager_CreateWriter_Params_Data*>(data);

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->client, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->client,
                                                 validation_context)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->options, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->options, validation_context))
    return false;

  return true;
}

AIManager_CreateWriter_Params_Data::AIManager_CreateWriter_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool AIManager_CreateRewriter_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AIManager_CreateRewriter_Params_Data* object =
      static_cast<const AIManager_CreateRewriter_Params_Data*>(data);

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->client, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->client,
                                                 validation_context)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->options, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->options, validation_context))
    return false;

  return true;
}

AIManager_CreateRewriter_Params_Data::AIManager_CreateRewriter_Params_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace blink

namespace perfetto {

// static
void TraceFormatTraits<::blink::mojom::ModelAvailabilityCheckResult>::WriteIntoTrace(
   perfetto::TracedValue context, ::blink::mojom::ModelAvailabilityCheckResult value) {
  return std::move(context).WriteString(::blink::mojom::ModelAvailabilityCheckResultToString(value));
}

} // namespace perfetto

namespace perfetto {

// static
void TraceFormatTraits<::blink::mojom::AIAssistantInitialPromptRole>::WriteIntoTrace(
   perfetto::TracedValue context, ::blink::mojom::AIAssistantInitialPromptRole value) {
  return std::move(context).WriteString(::blink::mojom::AIAssistantInitialPromptRoleToString(value));
}

} // namespace perfetto