// ui/events/mojom/event_latency_metadata.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef UI_EVENTS_MOJOM_EVENT_LATENCY_METADATA_MOJOM_SHARED_H_
#define UI_EVENTS_MOJOM_EVENT_LATENCY_METADATA_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "ui/events/mojom/event_latency_metadata.mojom-shared-internal.h"
#include "mojo/public/mojom/base/time.mojom-shared.h"







namespace ui::mojom {
class EventLatencyMetadataDataView;



}  // ui::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::ui::mojom::EventLatencyMetadataDataView> {
  using Data = ::ui::mojom::internal::EventLatencyMetadata_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace ui::mojom {


class EventLatencyMetadataDataView {
 public:
  EventLatencyMetadataDataView() = default;

  EventLatencyMetadataDataView(
      internal::EventLatencyMetadata_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetArrivedInBrowserMainTimestampDataView(
      ::mojo_base::mojom::TimeTicksDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadArrivedInBrowserMainTimestamp(UserType* output) {
    
    auto* pointer = data_->arrived_in_browser_main_timestamp.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeTicksDataView>(
        pointer, output, message_);
  }
  inline void GetScrollsBlockingTouchDispatchedToRendererDataView(
      ::mojo_base::mojom::TimeTicksDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadScrollsBlockingTouchDispatchedToRenderer(UserType* output) {
    
    auto* pointer = data_->scrolls_blocking_touch_dispatched_to_renderer.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeTicksDataView>(
        pointer, output, message_);
  }
  inline void GetDispatchedToRendererDataView(
      ::mojo_base::mojom::TimeTicksDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadDispatchedToRenderer(UserType* output) {
    
    auto* pointer = data_->dispatched_to_renderer.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeTicksDataView>(
        pointer, output, message_);
  }
 private:
  internal::EventLatencyMetadata_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


}  // ui::mojom

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::ui::mojom::EventLatencyMetadataDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::ui::mojom::EventLatencyMetadataDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::ui::mojom::internal::EventLatencyMetadata_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::arrived_in_browser_main_timestamp(input)) in_arrived_in_browser_main_timestamp = Traits::arrived_in_browser_main_timestamp(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->arrived_in_browser_main_timestamp)::BaseType> arrived_in_browser_main_timestamp_fragment(
            fragment.message());
    mojo::internal::Serialize<::mojo_base::mojom::TimeTicksDataView>(
        in_arrived_in_browser_main_timestamp, arrived_in_browser_main_timestamp_fragment);
    fragment->arrived_in_browser_main_timestamp.Set(
        arrived_in_browser_main_timestamp_fragment.is_null() ? nullptr : arrived_in_browser_main_timestamp_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->arrived_in_browser_main_timestamp.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null arrived_in_browser_main_timestamp in EventLatencyMetadata struct");
    decltype(Traits::scrolls_blocking_touch_dispatched_to_renderer(input)) in_scrolls_blocking_touch_dispatched_to_renderer = Traits::scrolls_blocking_touch_dispatched_to_renderer(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->scrolls_blocking_touch_dispatched_to_renderer)::BaseType> scrolls_blocking_touch_dispatched_to_renderer_fragment(
            fragment.message());
    mojo::internal::Serialize<::mojo_base::mojom::TimeTicksDataView>(
        in_scrolls_blocking_touch_dispatched_to_renderer, scrolls_blocking_touch_dispatched_to_renderer_fragment);
    fragment->scrolls_blocking_touch_dispatched_to_renderer.Set(
        scrolls_blocking_touch_dispatched_to_renderer_fragment.is_null() ? nullptr : scrolls_blocking_touch_dispatched_to_renderer_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->scrolls_blocking_touch_dispatched_to_renderer.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null scrolls_blocking_touch_dispatched_to_renderer in EventLatencyMetadata struct");
    decltype(Traits::dispatched_to_renderer(input)) in_dispatched_to_renderer = Traits::dispatched_to_renderer(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->dispatched_to_renderer)::BaseType> dispatched_to_renderer_fragment(
            fragment.message());
    mojo::internal::Serialize<::mojo_base::mojom::TimeTicksDataView>(
        in_dispatched_to_renderer, dispatched_to_renderer_fragment);
    fragment->dispatched_to_renderer.Set(
        dispatched_to_renderer_fragment.is_null() ? nullptr : dispatched_to_renderer_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->dispatched_to_renderer.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null dispatched_to_renderer in EventLatencyMetadata struct");
  }

  static bool Deserialize(::ui::mojom::internal::EventLatencyMetadata_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::ui::mojom::EventLatencyMetadataDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace ui::mojom {

inline void EventLatencyMetadataDataView::GetArrivedInBrowserMainTimestampDataView(
    ::mojo_base::mojom::TimeTicksDataView* output) {
  auto pointer = data_->arrived_in_browser_main_timestamp.Get();
  *output = ::mojo_base::mojom::TimeTicksDataView(pointer, message_);
}
inline void EventLatencyMetadataDataView::GetScrollsBlockingTouchDispatchedToRendererDataView(
    ::mojo_base::mojom::TimeTicksDataView* output) {
  auto pointer = data_->scrolls_blocking_touch_dispatched_to_renderer.Get();
  *output = ::mojo_base::mojom::TimeTicksDataView(pointer, message_);
}
inline void EventLatencyMetadataDataView::GetDispatchedToRendererDataView(
    ::mojo_base::mojom::TimeTicksDataView* output) {
  auto pointer = data_->dispatched_to_renderer.Get();
  *output = ::mojo_base::mojom::TimeTicksDataView(pointer, message_);
}



}  // ui::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

#endif  // UI_EVENTS_MOJOM_EVENT_LATENCY_METADATA_MOJOM_SHARED_H_